/*
 * Copyright (C) 2007-2019 Artima, Inc. All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Example code from:
 *
 * Programming in Scala, Fifth Edition
 * by Martin Odersky, Lex Spoon, Bill Venners, and Frank Sommers
 *
 * http://booksites.artima.com/programming_in_scala_5ed
 */

package org.stairwaybook.workingwithlists

object InsertionSort2 {
  def isort(xs: List[Int]): List[Int] =
    xs match
      case List()   => List()
      case x :: xs1 => insert(x, isort(xs1))
  
  
  def insert(x: Int, xs: List[Int]): List[Int] =
    xs match
      case List()  => List(x)
      case y :: ys => if x <= y then x :: xs
                      else y :: insert(x, ys)

  def main(args: Array[String]): Unit = {
    println("isort(List(5, 3, 12)) [" + isort(List(5, 3, 12)) + "]")
  }
}
